"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiffUtils = void 0;
var cloneDeep = require("lodash.clonedeep");
var DiffUtils = /** @class */ (function () {
    function DiffUtils() {
    }
    DiffUtils.format = function (obj, options) {
        var _a, _b;
        var altered = __assign({}, obj);
        if (!!((_a = options === null || options === void 0 ? void 0 : options.diff) === null || _a === void 0 ? void 0 : _a.ignoreKeys)) {
            altered = this.removeKeysRecursively(altered, options.diff.ignoreKeys);
        }
        if ((_b = options === null || options === void 0 ? void 0 : options.diff) === null || _b === void 0 ? void 0 : _b.sortArrays) {
            altered = this.sortArraysRecursively(altered, options.diff.sortBy);
        }
        return altered;
    };
    DiffUtils.sortArraysRecursively = function (obj, sortBy) {
        var _this = this;
        if (!!obj) {
            var clonedObj_2 = cloneDeep(obj);
            if (clonedObj_2 instanceof Array) {
                clonedObj_2.sort(function (a, b) {
                    if (!!sortBy) {
                        var sortKey = sortBy.find(function (key) { return a.hasOwnProperty(key); });
                        if (!!sortKey) {
                            return a[sortKey].localeCompare(b[sortKey]);
                        }
                    }
                    return JSON.stringify(a).localeCompare(JSON.stringify(b));
                });
                var newArray = [];
                for (var _i = 0, clonedObj_1 = clonedObj_2; _i < clonedObj_1.length; _i++) {
                    var element = clonedObj_1[_i];
                    newArray.push(this.sortArraysRecursively(element, sortBy));
                }
                clonedObj_2 = newArray;
            }
            else if (typeof clonedObj_2 === "object") {
                Object.getOwnPropertyNames(clonedObj_2).forEach(function (key) { return (clonedObj_2[key] = _this.sortArraysRecursively(clonedObj_2[key], sortBy)); });
            }
            return clonedObj_2;
        }
        return obj;
    };
    DiffUtils.removeKeysRecursively = function (obj, keys) {
        var _this = this;
        if (!!obj) {
            var clonedObj_4 = cloneDeep(obj);
            if (clonedObj_4 instanceof Array) {
                var newArray = [];
                for (var _i = 0, clonedObj_3 = clonedObj_4; _i < clonedObj_3.length; _i++) {
                    var element = clonedObj_3[_i];
                    newArray.push(this.removeKeysRecursively(element, keys));
                }
                clonedObj_4 = newArray;
            }
            else if (typeof clonedObj_4 === "object") {
                Object.getOwnPropertyNames(clonedObj_4).forEach(function (key) {
                    if (keys.indexOf(key) !== -1)
                        delete clonedObj_4[key];
                    else {
                        clonedObj_4[key] = _this.removeKeysRecursively(clonedObj_4[key], keys);
                    }
                });
            }
            return clonedObj_4;
        }
        return obj;
    };
    return DiffUtils;
}());
exports.DiffUtils = DiffUtils;
