"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
var chalk = require("chalk");
var figlet = require("figlet");
var Logger = /** @class */ (function () {
    function Logger() {
    }
    Logger.linebreak = function () {
        this.log("");
    };
    Logger.banner = function (message) {
        this.logColour("blueBright", figlet.textSync(message, { font: "small", horizontalLayout: "full" }));
    };
    Logger.info = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.logColour.apply(this, __spreadArray(["blue", "INFO: " + message[0]], message.slice(1), false));
    };
    Logger.error = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.logColour.apply(this, __spreadArray(["red", "ERROR: " + message[0]], message.slice(1), false));
    };
    Logger.errorWithStack = function (message, e) {
        console.log(chalk(templateObject_1 || (templateObject_1 = __makeTemplateObject(["{red ", "}"], ["{red ", "}"])), message));
        console.log(e);
    };
    Logger.log = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.logColour.apply(this, __spreadArray(["whiteBright"], message, false));
    };
    Logger.logColour = function (color) {
        if (color === void 0) { color = "white"; }
        var message = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            message[_i - 1] = arguments[_i];
        }
        var string = message.reduce(function (prev, current) {
            var currentString = typeof current === "object"
                ? JSON.stringify(current, null, 2)
                : current;
            return "" + prev + (!!prev ? "\n" : "") + currentString;
        }, "");
        console.log(chalk(templateObject_2 || (templateObject_2 = __makeTemplateObject(["{", " ", "}"], ["{", " ", "}"])), color, string));
    };
    return Logger;
}());
exports.Logger = Logger;
var templateObject_1, templateObject_2;
