"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationSchema = void 0;
var ConfigurationSchema = /** @class */ (function () {
    function ConfigurationSchema() {
    }
    Object.defineProperty(ConfigurationSchema, "schema", {
        get: function () {
            return this._schema;
        },
        enumerable: false,
        configurable: true
    });
    ConfigurationSchema._substitutionsSchema = {
        type: "object",
        required: [],
        nullable: true,
        patternProperties: {
            ".{1,}": {
                oneOf: [
                    { type: "string", nullable: false },
                    { type: "number", nullable: false },
                ],
            },
        },
    };
    ConfigurationSchema._endpointOptionsSchema = {
        type: "object",
        required: [],
        nullable: true,
        properties: {
            diff: {
                type: "object",
                required: [],
                nullable: true,
                properties: {
                    enabled: {
                        type: "boolean",
                        nullable: true,
                    },
                    sortArrays: {
                        type: "boolean",
                        nullable: true,
                    },
                    sortBy: {
                        type: "array",
                        nullable: true,
                        items: {
                            type: "string",
                        },
                    },
                    ignoreKeys: {
                        type: "array",
                        nullable: true,
                        items: {
                            type: "string",
                        },
                    },
                },
            },
        },
    };
    ConfigurationSchema._globalConfigurationOptionsSchema = {
        type: "object",
        required: [],
        properties: __assign(__assign({}, ConfigurationSchema._endpointOptionsSchema.properties), { htmlReport: {
                type: "object",
                required: [],
                nullable: true,
                properties: {
                    theme: {
                        type: "string",
                        nullable: true,
                        enum: ["light", "dark"],
                    },
                },
            } }),
    };
    ConfigurationSchema._endpointSchema = {
        type: "object",
        required: [],
        properties: {
            candidatePath: {
                type: "string",
                nullable: true,
            },
            substitutions: __assign(__assign({}, ConfigurationSchema._substitutionsSchema), { nullable: true }),
            headers: {
                type: "object",
                required: [],
                nullable: true,
                patternProperties: {
                    ".{1,}": { type: "string", nullable: false },
                },
            },
            options: __assign(__assign({}, ConfigurationSchema._endpointOptionsSchema), { nullable: true }),
        },
    };
    ConfigurationSchema._serviceConfigurationSchema = {
        type: "object",
        required: ["url"],
        properties: {
            url: { type: "string", nullable: false },
            headers: {
                type: "object",
                required: [],
                nullable: true,
                patternProperties: {
                    ".{1,}": { type: "string", nullable: false },
                },
            },
        },
    };
    ConfigurationSchema._globalConfigurationSchema = {
        type: "object",
        required: [],
        properties: {
            substitutions: __assign(__assign({}, ConfigurationSchema._substitutionsSchema), { nullable: true }),
            headers: {
                type: "object",
                required: [],
                nullable: true,
                patternProperties: {
                    ".{1,}": { type: "string", nullable: false },
                },
            },
            options: __assign(__assign({}, ConfigurationSchema._globalConfigurationOptionsSchema), { nullable: true }),
        },
    };
    ConfigurationSchema._schema = {
        type: "object",
        required: ["endpoints", "configuration"],
        properties: {
            endpoints: {
                type: "object",
                minProperties: 1,
                required: [],
                patternProperties: {
                    ".{1,}": ConfigurationSchema._endpointSchema,
                },
            },
            configuration: {
                type: "object",
                required: ["control", "candidate"],
                properties: {
                    global: __assign(__assign({}, ConfigurationSchema._globalConfigurationSchema), { nullable: true }),
                    control: ConfigurationSchema._serviceConfigurationSchema,
                    candidate: ConfigurationSchema._serviceConfigurationSchema,
                },
            },
        },
    };
    return ConfigurationSchema;
}());
exports.ConfigurationSchema = ConfigurationSchema;
