"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceComparator = void 0;
var axios_http_client_1 = require("./axios-http-client");
var ServiceComparator = /** @class */ (function () {
    function ServiceComparator(configuration) {
        this._configuration = configuration;
        this._httpClient = new axios_http_client_1.AxiosHttpClient();
    }
    ServiceComparator.prototype.compare = function (path, endpointConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var substitute, controlPath, candidatePath, controlResult, candidateResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        substitute = function (input) {
                            var substitutions = __assign({}, (endpointConfig.substitutions || {}));
                            var substitutedPath = input;
                            Object.keys(substitutions).forEach(function (key) {
                                substitutedPath = substitutedPath.replace("{" + key + "}", substitutions[key]);
                            });
                            return substitutedPath;
                        };
                        controlPath = substitute(path);
                        candidatePath = substitute(endpointConfig.candidatePath || path);
                        return [4 /*yield*/, this._httpClient.get("" + this._configuration.configuration.control.url + controlPath, __assign(__assign({}, (this._configuration.configuration.control.headers || {})), (endpointConfig.headers || {})))];
                    case 1:
                        controlResult = _a.sent();
                        return [4 /*yield*/, this._httpClient.get("" + this._configuration.configuration.candidate.url + candidatePath, __assign(__assign({}, (this._configuration.configuration.candidate.headers || {})), (endpointConfig.headers || {})))];
                    case 2:
                        candidateResult = _a.sent();
                        return [2 /*return*/, Promise.resolve({
                                actualPath: {
                                    pretty: controlPath === candidatePath ? "'" + controlPath + "'" : "Control: '" + controlPath + "'   |   Candidate: '" + candidatePath + "'",
                                    control: controlPath,
                                    candidate: candidatePath,
                                    match: controlPath === candidatePath,
                                },
                                status: {
                                    pretty: "Control: " + controlResult.status + " -> Candidate: " + candidateResult.status,
                                    control: controlResult.status,
                                    candidate: candidateResult.status,
                                    match: controlResult.status === candidateResult.status,
                                    metadata: {
                                        eitherPathErrored: ServiceComparator.isErrorStatus(controlResult.status) || ServiceComparator.isErrorStatus(candidateResult.status),
                                    },
                                },
                                responseTime: {
                                    pretty: ServiceComparator.createResponseTimeString(controlResult.responseTime, candidateResult.responseTime),
                                    control: controlResult.responseTime,
                                    candidate: candidateResult.responseTime,
                                    match: controlResult.responseTime === candidateResult.responseTime,
                                    metadata: {
                                        unit: "milliseconds",
                                        percentage: {
                                            value: Math.abs(Math.round((controlResult.responseTime / candidateResult.responseTime) * 100) - 100),
                                        },
                                    },
                                },
                                responseBody: {
                                    control: controlResult.response.body.value,
                                    candidate: candidateResult.response.body.value,
                                    match: ServiceComparator.isMatch(controlResult.response.body.value, candidateResult.response.body.value, controlResult.response.body.isJson && candidateResult.response.body.isJson),
                                    metadata: {
                                        isJson: controlResult.response.body.isJson && candidateResult.response.body.isJson,
                                    },
                                },
                            })];
                }
            });
        });
    };
    ServiceComparator.createResponseTimeString = function (leftMillis, rightMillis) {
        return "Control: " + leftMillis + "ms -> Candidate: " + rightMillis + "ms";
    };
    ServiceComparator.isErrorStatus = function (status) {
        return status >= 400;
    };
    ServiceComparator.isMatch = function (left, right, isJson) {
        if (isJson) {
            return JSON.stringify(left) === JSON.stringify(right);
        }
        return left === right;
    };
    return ServiceComparator;
}());
exports.ServiceComparator = ServiceComparator;
